﻿Liquid_Wealth = LibStub("AceAddon-3.0"):NewAddon("Liquid-Wealth","AceEvent-3.0", "AceConsole-3.0", "AceComm-3.0", "AceSerializer-3.0"); --Declare Ace3 Addon
local LibQTip = LibStub("LibQTip-1.0")
local ldb_obj = LibStub("LibDataBroker-1.1"):NewDataObject("Liquid_Wealth", {icon = "Interface\\Icons\\INV_Misc_Coin_02.png",label = "Liquid-Wealth",type = "data source",text = "Liquid-Wealth"}); --Declare LibDataBroker Plugin
local abacus = LibStub("LibAbacus-3.0");

function Liquid_Wealth:OnInitialize()
    -- Called when the addon is loaded
    self.db = LibStub("AceDB-3.0"):New("Liquid_WealthDB")
    LibStub("AceConfig-3.0"):RegisterOptionsTable("Liquid-Wealth", CommandLineOptions) --loads the command line support.
    --LibStub("AceConfig-3.0"):RegisterOptionsTable("Liquid-Wealth Remote Toon Config", CommandLineOptionsRTC) --loads the command line support.
    LibStub("AceConfigDialog-3.0"):AddToBlizOptions("Liquid-Wealth","Liquid-Wealth")
    --LibStub("AceConfigDialog-3.0"):AddToBlizOptions("Liquid_Wealth Remote Toon Config","Remote Toon Config", "Liquid_Wealth")
    varCurrentPlayer = UnitName("player"); --Gets the toons name of the current player.
    Liquid_Wealth:CheckMasterDatabase();
	Liquid_Wealth:NewToonEntery(varCurrentPlayer,"local",Liquid_Wealth:genHexPSK(),UnitSex("Player"),UnitRace("Player"),UnitClass("Player"));
	Liquid_Wealth:CheckGuildInfo();
end

function Liquid_Wealth:OnEnable()
    self:Print("Liquid_Wealth Now Running");
    varIsBankFrameOpen = false;
	tabsNotScanned = {}
	--self:RegisterEvent("PLAYER_ENTERING_WORLD")
    self:RegisterEvent("BANKFRAME_OPENED");
    self:RegisterEvent("BANKFRAME_CLOSED");
   -- self:RegisterEvent("BAG_UPDATE");
	self:RegisterEvent("PLAYER_GUILD_UPDATE");
    self:RegisterComm("LMAC")
	self:RegisterEvent("GUILDBANKFRAME_OPENED")
	self:RegisterEvent("GUILDBANKFRAME_CLOSED")
	self:RegisterEvent("GUILD_ROSTER_UPDATE")
	Liquid_Wealth:CheckGuildInfo();
	if (Liquid_Wealth.db.profile.displayMode == "GuildBank") then
		ldb_obj.text="Liquid-Wealth: Guild Bank";
	else
		ldb_obj.text="Liquid-Wealth: Player";
	end
end
	
ITEM_BIND_ON_EQUIP = "Binds when equipped"; -- Item will be bound when equipped
ITEM_BIND_ON_PICKUP = "Binds when picked up"; -- Item wil be bound when picked up
ITEM_BIND_ON_USE = "Binds when used"; -- Item will be bound when used
ITEM_BIND_QUEST = "Quest Item"; -- Item is a quest item (same logic as ON_PICKUP)
ITEM_SOULBOUND = "Soulbound"; -- Item is Soulbound

function Liquid_Wealth:IsItemSoulbound(bagId,slot)
	local tooltip = LibStub:GetLibrary("LibGratuity-3.0")
    local ContainerItemLink = GetContainerItemLink(bagId, slot)
    if ContainerItemLink then
        local _, _, iRarity, _, _, sType, sSubType, _, sEquipLoc = GetItemInfo(ContainerItemLink)
        tooltip:SetBagItem(bagId,slot)
        if  (iRarity >= 2) and (sType == 'Armor') or (sType == 'Weapon') and not tooltip:Find(ITEM_SOULBOUND, 1, 3 ) then
			return true
		else
			return false
        end
    end
end
	
function Liquid_Wealth:PLAYER_GUILD_UPDATE()
	--self:Print("Updating Guild Info")
	local guildName, guildRankName, guildRankIndex = GetGuildInfo("Player");
	Liquid_Wealth:UpdateCurrentToonGuildInfo(UnitName("player"),guildName,guildRankIndex,guildRankName)
end

function Liquid_Wealth:GUILD_ROSTER_UPDATE()
	--self:Print("Updating Guild Info")
	local guildName, guildRankName, guildRankIndex = GetGuildInfo("Player");
	Liquid_Wealth:UpdateCurrentToonGuildInfo(UnitName("player"),guildName,guildRankIndex,guildRankName)
end

function Liquid_Wealth:GUILDBANKFRAME_CLOSED()
	if next(tabsNotScanned) then
		-- Tabs never opened cannot be scanned. And no, force looping SetGuildCurrentGuildBankTab() doesn't work either, you really do have to wait until it populates (server roundtrip). This obviously can't be done on the bank closing.
		self:Print("Guild bank tabs not scanned: "..table.concat(tabsNotScanned, ", "))
		tabsNotScanned = {}
	end
end

function Liquid_Wealth:GUILDBANKFRAME_OPENED()
	local guildName, guildRankName, guildRankIndex = GetGuildInfo("Player");
	if not Liquid_Wealth:CheckGuildBank(guildName) then
		Liquid_Wealth.db.realm.guild[guildName] = {}
		Liquid_Wealth:ScanGuildBank(guildName)
	else
		Liquid_Wealth:ScanGuildBank(guildName)
	end
end

function Liquid_Wealth:PLAYER_ENTERING_WORLD()
    if not InCombatLockdown() then	
		Liquid_Wealth:Scan(0,4);
    end
end

function Liquid_Wealth:BAG_UPDATE(bagID)
    if not InCombatLockdown() then	
        --if (not Liquid_Wealth.db.realm.toon[varCurrentPlayer].bagID[0]) then Liquid_Wealth:Scan(0,0); end
		self:Print(bagID)
        if (bagID > -1 and bagID < 5) and (not varIsBankFrameOpen) then --Update Only The Local Bags
            Liquid_Wealth:Scan(bagID,bagID) --Tells the scan function to scan only the bags that change
        end
    end
end

function Liquid_Wealth:forceScan(command)
	if command == 1 then --Force Scan Bags
		Liquid_Wealth:Scan(0,4);
	elseif command == 2 then --Force Scan Banks
		Liquid_Wealth:Scan(-1,-1);
		Liquid_Wealth:Scan(5,11);
	else --Force Scan Using Remote Inv Addon.

	end
end

function Liquid_Wealth:Scan(startbag,endbag)
	local bagLink=""
	if (startbag == endbag) then				
		if (GetContainerNumSlots(startbag)>=1) and (startbag>0) then --Check to see if player had bag equipped, and to skip bank and backpack
			local invID = ContainerIDToInventoryID(startbag);
			bagLink = GetInventoryItemLink("player",invID);
		elseif startbag==-1 then --Bank
			bagLink="Bank";
		elseif startbag==0 then --Backpack
			bagLink="Backpack";
		else
		    bagLink = "NONE" -- Set the Item ID to none if the player didn't buy a bank/equipped bag or bank slot.
		end 
		Liquid_Wealth.db.realm.toon[varCurrentPlayer].bagID[startbag] = Liquid_Wealth:ConvItemDataToDB(bagLink,Liquid_Wealth:GetBagValueVender(startbag),Liquid_Wealth:GetBagValueAuction(startbag));
	else	
		for bagId = startbag, endbag do -- Add up the value of each bag's contents
			if (GetContainerNumSlots(bagId)>=1) and (bagId>0) then --Check to see if player had bag equipped, and to skip bank and backpack
				local invID = ContainerIDToInventoryID(bagId);
				bagLink = GetInventoryItemLink("player",invID);
			elseif bagId==-1 then --Bank
				bagLink="Bank";
			elseif bagId==0 then --Backpack
			    bagLink="Backpack";
			else
			    bagLink = "NONE" -- Set the Item ID to none if the player didn't buy a bank/equipped bag or bank slot.
			end 
			Liquid_Wealth.db.realm.toon[varCurrentPlayer].bagID[bagId] = Liquid_Wealth:ConvItemDataToDB(bagLink,Liquid_Wealth:GetBagValueVender(bagId),Liquid_Wealth:GetBagValueAuction(bagId));
		end
	end	
	Liquid_Wealth.db.realm.toon[varCurrentPlayer].playergold = GetMoney();
	Liquid_Wealth.db.realm.toon[varCurrentPlayer].lastChecked = date("%m/%d/%y %I:%M:%S %p");
end

function Liquid_Wealth:BANKFRAME_OPENED()
    if not InCombatLockdown() then
        varIsBankFrameOpen = true;
        Liquid_Wealth:Scan(-1,11)--Loop though all the bags and bank bags
    end
end

function Liquid_Wealth:BANKFRAME_CLOSED()
    if not InCombatLockdown() then	
        varIsBankFrameOpen = false;
    end
end

function Liquid_Wealth:CharTotal(toon)
    local VenderTotal=0;
    local AuctionTotal = 0;
    for bagId = -1, 11 do -- Add up the value of each bag's contents
        local _,Vender,Auction=Liquid_Wealth:ConvItemDataFromDB(bagId,toon);
        VenderTotal=VenderTotal+Vender;
        AuctionTotal=AuctionTotal+Auction;
    end
    -- VenderTotal=VenderTotal+Liquid_Wealth.db.realm.toon[toon].playergold;
    -- AuctionTotal=AuctionTotal+Liquid_Wealth.db.realm.toon[toon].playergold;
    return VenderTotal,AuctionTotal
end

function Liquid_Wealth:ConfigToolTip()
	tip =  LibQTip:Acquire("Liquid_WealthTooltip", 3, "LEFT", "CENTER", "RIGHT")
	tip:Clear()
	tip:SetScale(1)
	tip:EnableMouse(true)
	if _G.TipTac and _G.TipTac.AddModifiedTip then
		-- Pass true as second parameter because hooking OnHide causes C stack overflows
		_G.TipTac:AddModifiedTip(tip, true)
	end
	
	tip:SetCell(tip:AddHeader(""), 1, "Liquid-Wealth", nil, "CENTER", 3)
	
	if (Liquid_Wealth.db.profile.displayMode == "GuildBank") then
		Liquid_Wealth:showGuildBankToolTip()
	else
		Liquid_Wealth:ConfigPlayerTooltip()
	end
	Liquid_Wealth:FixCellSizes(tip)
end 

function Liquid_Wealth:ConfigPlayerTooltip()
	tip:SetCell(tip:AddHeader(""), 1,"Current Selected Player: "..Liquid_Wealth:BuildIcons(Liquid_Wealth.db.realm.toon[varCurrentPlayer].unitID).." "..varCurrentPlayer,nil,"CENTER", 3)
	modeHeader=tip:AddHeader("")
	--tip:SetCell(modeHeader, 1,"Player", nil, "CENTER")
	if Liquid_Wealth.db.profile.gdisplayMode=="Vender" then
		tip:SetCell(modeHeader, 1, "Value Mode: Vender",nil,"CENTER",3)
	else
		tip:SetCell(modeHeader, 1, "Value Mode: Auction",nil,"CENTER",3)
	end
	tip:SetCellScript(modeHeader,1, "OnMouseDown", function() Liquid_Wealth:ChangeViewModes() end);
	
	header=tip:AddHeader("")
	tip:SetCell(header, 1, format("|TInterface\\Buttons\\UI-%sButton-Up:18:18:1:0|t".."Player Bags", Liquid_Wealth.db.profile.noBagInfoTip and "Plus" or "Minus"))
	tip:SetCellScript(header, 1, "OnMouseDown", function() 
		Liquid_Wealth.db.profile.noBagInfoTip = not Liquid_Wealth.db.profile.noBagInfoTip 
		Liquid_Wealth:ToolTipUpDate() 
		end)
	tip:SetCell(header, 3,"Value")
	
	local playerDetail = tip:AddLine("")
  if (Liquid_Wealth.db.realm.toon[varCurrentPlayer].bagId==nil) and (Liquid_Wealth.db.realm.toon[varCurrentPlayer].lastChecked==0) then
    tip:SetCell(playerDetail, 1,Liquid_Wealth:BuildBagIcons("Backpack").." Backpack" , nil , "LEFT"  , 1)
    tip:SetCell(playerDetail, 2,"Sorry No Data Yet, Please Scan Now",nil, "Center"  , 2)
  else
   if Liquid_Wealth.db.profile.noBagInfoTip then
        local VenderTotal=0;
        local AuctionTotal=0;
        for bagId = 0, 4 do -- Add up the value of each bag's contents
            _,Vender,Auction=Liquid_Wealth:ConvItemDataFromDB(bagId,varCurrentPlayer)
            VenderTotal=VenderTotal+Vender
            AuctionTotal=AuctionTotal+Auction
        end
       
        tip:SetCell(playerDetail, 1,Liquid_Wealth:BuildBagIcons("Backpack").." Backpack's" , nil , "LEFT"  , 1)
		if Liquid_Wealth.db.profile.gdisplayMode=="Vender" then
			tip:SetCell(playerDetail, 3,abacus:FormatMoneyFull(VenderTotal,true),nil, "RIGHT"  , 1)
		else
			tip:SetCell(playerDetail, 3,abacus:FormatMoneyFull(AuctionTotal,true),nil, "RIGHT"  , 1)
		end
   else
        local BagItemLink,VenderTotal,AuctionTotal=Liquid_Wealth:ConvItemDataFromDB(0,varCurrentPlayer)
        tip:SetCell(playerDetail, 1,Liquid_Wealth:BuildBagIcons(BagItemLink).." Backpack" , nil , "LEFT"  , 1)
        if Liquid_Wealth.db.profile.gdisplayMode=="Vender" then
			tip:SetCell(playerDetail, 3,abacus:FormatMoneyFull(VenderTotal,true),nil, "RIGHT"  , 1)
		else
			tip:SetCell(playerDetail, 3,abacus:FormatMoneyFull(AuctionTotal,true),nil, "RIGHT"  , 1)
		end

        for bagId = 1, 4 do -- Add up the value of each bag's contents
            local BagItemLink,VenderTotal,AuctionTotal=Liquid_Wealth:ConvItemDataFromDB(bagId,varCurrentPlayer)
            local playerDetail = tip:AddLine("")
            if (BagItemLink=="NONE") or (BagItemLink==0) then    
                tip:SetCell(playerDetail, 1,Liquid_Wealth:BuildBagIcons(BagItemLink).." Not Equipped",nil, "LEFT"  , 1)
				if Liquid_Wealth.db.profile.gdisplayMode=="Vender" then
					tip:SetCell(playerDetail, 3,abacus:FormatMoneyFull(VenderTotal,true),nil, "RIGHT"  , 1)
				else
					tip:SetCell(playerDetail, 3,abacus:FormatMoneyFull(AuctionTotal,true),nil, "RIGHT"  , 1)  
				end    
            else
                local itemName, _, _, _, _, _, _, _, _, _ = GetItemInfo(BagItemLink) 
                tip:SetCell(playerDetail, 1,Liquid_Wealth:BuildBagIcons(BagItemLink)..""..itemName,nil, "LEFT"  , 1)
				if Liquid_Wealth.db.profile.gdisplayMode=="Vender" then
					tip:SetCell(playerDetail, 3,abacus:FormatMoneyFull(VenderTotal,true),nil, "RIGHT"  , 1)
				else
					tip:SetCell(playerDetail, 3,abacus:FormatMoneyFull(AuctionTotal,true),nil, "RIGHT"  , 1)  
				end  
            end
        end
   end
    
  end  
  tip:AddLine(" ")
  header=tip:AddHeader("")
  tip:SetCell(header, 1, format("|TInterface\\Buttons\\UI-%sButton-Up:18:18:1:0|t".."Bank Bags", Liquid_Wealth.db.profile.noBankInfoTip and "Plus" or "Minus"))
  tip:SetCellScript(header, 1, "OnMouseDown", function() 
	Liquid_Wealth.db.profile.noBankInfoTip = not Liquid_Wealth.db.profile.noBankInfoTip 
	Liquid_Wealth:ToolTipUpDate() 
	end)
  tip:SetCell(header, 3,"Value")
  local playerDetail = tip:AddLine("")
  if ((not Liquid_Wealth.db.realm.toon[varCurrentPlayer].bagID) and (Liquid_Wealth.db.realm.toon[varCurrentPlayer].lastChecked==0)) or (not Liquid_Wealth.db.realm.toon[varCurrentPlayer].bagID[-1]) then
    tip:SetCell(playerDetail, 1,Liquid_Wealth:BuildBagIcons("Bank").." Bank" , nil , "LEFT"  , 1)
    tip:SetCell(playerDetail, 2,"Sorry No Data Yet, Please Scan Now",nil, "CENTER"  , 2)
  else
    if Liquid_Wealth.db.profile.noBankInfoTip then
        local VenderTotal=0;
        local AuctionTotal=0;
        for bagId = 5, 11 do -- Add up the value of each bag's contents
            _,Vender,Auction=Liquid_Wealth:ConvItemDataFromDB(bagId,varCurrentPlayer)
            VenderTotal=VenderTotal+Vender
            AuctionTotal=AuctionTotal+Auction
        end
        _,Vender,_=Liquid_Wealth:ConvItemDataFromDB(-1,varCurrentPlayer)
        _,_,Auction=Liquid_Wealth:ConvItemDataFromDB(-1,varCurrentPlayer)
        VenderTotal=VenderTotal+Vender
        AuctionTotal=AuctionTotal+Auction
        tip:SetCell(playerDetail, 1,Liquid_Wealth:BuildBagIcons("Bank").." Bank's" , nil , "LEFT"  , 1)
		if Liquid_Wealth.db.profile.gdisplayMode=="Vender" then
			tip:SetCell(playerDetail, 3,abacus:FormatMoneyFull(VenderTotal,true),nil, "RIGHT"  , 1)
		else
			tip:SetCell(playerDetail, 3,abacus:FormatMoneyFull(AuctionTotal,true),nil, "RIGHT"  , 1)
		end
        
    else
        local BagItemLink,VenderTotal,AuctionTotal=Liquid_Wealth:ConvItemDataFromDB(-1,varCurrentPlayer)
        tip:SetCell(playerDetail, 1,Liquid_Wealth:BuildBagIcons("Bank").." Bank" , nil , "LEFT"  , 1)
		if Liquid_Wealth.db.profile.gdisplayMode=="Vender" then
			tip:SetCell(playerDetail, 3,abacus:FormatMoneyFull(VenderTotal,true),nil, "RIGHT"  , 1)
		else
			tip:SetCell(playerDetail, 3,abacus:FormatMoneyFull(AuctionTotal,true),nil, "RIGHT"  , 1)
		end
        
        for bagId = 5, 11 do -- Add up the value of each bag's contents
            local BagItemLink,VenderTotal,AuctionTotal=Liquid_Wealth:ConvItemDataFromDB(bagId,varCurrentPlayer)
            local playerDetail = tip:AddLine("")
            if (BagItemLink=="NONE") then
                tip:SetCell(playerDetail, 1,Liquid_Wealth:BuildBagIcons(BagItemLink).." Not Equipped",nil, "LEFT"  , 1)
				if Liquid_Wealth.db.profile.gdisplayMode=="Vender" then
				    tip:SetCell(playerDetail, 3,abacus:FormatMoneyFull(VenderTotal,true),nil, "RIGHT"  , 1)
				else
					tip:SetCell(playerDetail, 3,abacus:FormatMoneyFull(AuctionTotal,true),nil, "RIGHT"  , 1)  
				end
            else
                local itemName, _, _, _, _, _, _, _, _, _ = GetItemInfo(BagItemLink) 
                tip:SetCell(playerDetail, 1,Liquid_Wealth:BuildBagIcons(BagItemLink)..""..itemName,nil, "LEFT"  , 1)
				if Liquid_Wealth.db.profile.gdisplayMode=="Vender" then
					tip:SetCell(playerDetail, 3,abacus:FormatMoneyFull(VenderTotal,true),nil, "RIGHT"  , 1)
				else
					tip:SetCell(playerDetail, 3,abacus:FormatMoneyFull(AuctionTotal,true),nil, "RIGHT"  , 1)
				end    
            end
        end
    end
  end
  tip:AddLine(" ");
  local Header = tip:AddLine("");
  tip:SetCell(Header, 1, "|cffeda55fCharacter|r", nil, "LEFT"  , 1)
  tip:SetCell(Header, 2, "|cffeda55fScan Date|r", nil, "CENTER", 1) 
  if Liquid_Wealth.db.profile.gdisplayMode=="Vender" then
	tip:SetCell(Header, 3, "|cffeda55fTotal [Vender]|r", nil, "RIGHT", 1)  
  else
	tip:SetCell(Header, 3, "|cffeda55fTotal [Acution]|r", nil, "RIGHT", 1)  
  end  
  

  
  --Sorted List Goes Here
  Liquid_Wealth:returnSortedCharListed(tip)
end

function Liquid_Wealth:returnSortedCharListed(tip)
  local relamTotalVender=0;
  local relamTotalAuct=0;
  for chars in pairs(self.db.realm.toon) do
    local playerDetail = tip:AddLine("");
	
    if (Liquid_Wealth.db.realm.toon[chars].bagId==nil) and (Liquid_Wealth.db.realm.toon[chars].lastChecked==0) then
        tip:SetCell(playerDetail, 1, chars,nil, "LEFT"  , 1);
        tip:SetCell(playerDetail, 2, "Sorry No Data Yet, Please Scan Now",nil, "CENTER"  , 2);       
    else
        local vend,auct = Liquid_Wealth:CharTotal(chars);
		tip:SetLineScript(playerDetail, "OnMouseDown", function() Liquid_Wealth:ViewPlayer(chars) end);
        tip:SetCell(playerDetail, 1,Liquid_Wealth:BuildIcons(Liquid_Wealth.db.realm.toon[chars].unitID).." "..chars,nil, "LEFT"  , 1);
        tip:SetCell(playerDetail, 2,Liquid_Wealth.db.realm.toon[chars].lastChecked,nil, "CENTER" , 1);
		if Liquid_Wealth.db.profile.gdisplayMode=="Vender" then
			tip:SetCell(playerDetail, 3,abacus:FormatMoneyFull(vend,true),nil, "RIGHT"  , 1);
		else
			tip:SetCell(playerDetail, 3,abacus:FormatMoneyFull(auct,true),nil, "RIGHT"  , 1);
		end  
        relamTotalVender=relamTotalVender+vend;
        relamTotalAuct=relamTotalAuct+auct;
    end
  end
  local relamDetail = tip:AddLine("");
  tip:SetCell(relamDetail, 1, "Total Amount On Relam:",nil, "LEFT"  , 1);
  if Liquid_Wealth.db.profile.gdisplayMode=="Vender" then
  tip:SetCell(relamDetail, 2,abacus:FormatMoneyFull(relamTotalVender,true),nil, "RIGHT"  , 2);  
  else
  tip:SetCell(relamDetail, 2,abacus:FormatMoneyFull(relamTotalAuct,true),nil, "RIGHT"  , 2);  
  end 
  
end

function Liquid_Wealth:ToolTipUpDate()
Liquid_Wealth:ConfigToolTip()
tip:Show();
end

function Liquid_Wealth:ChangeViewModes()
	if Liquid_Wealth.db.profile.gdisplayMode=="Vender" then
		Liquid_Wealth.db.profile.gdisplayMode="Auction"
	else
		Liquid_Wealth.db.profile.gdisplayMode="Vender"
	end
	Liquid_Wealth:ConfigToolTip()
	tip:Show();
end

function Liquid_Wealth:ViewPlayer(Toon)
	varCurrentPlayer=Toon;
	Liquid_Wealth:ConfigToolTip()
	tip:Show();
end

local function HideTooltip()
  if MouseIsOver(tip) then return end
  tip:SetScript('OnLeave', nil)
  tooltipIsShown = false
  LibQTip:Release(tip)
end

function ldb_obj.OnLeave(self)
  if MouseIsOver(tip) then
    tip:SetScript('OnLeave', HideTooltip)
  else
    HideTooltip()
  end
end

function ldb_obj.OnEnter(self)
	Liquid_Wealth:ConfigToolTip()
    tip:SmartAnchorTo(self)
    tip:Show()
end

function ldb_obj.OnClick(self, button)
	if button == "RightButton" then		
		InterfaceOptionsFrame_OpenToCategory("Liquid-Wealth");
	else
		if (Liquid_Wealth.db.profile.displayMode == "GuildBank") then
			Liquid_Wealth.db.profile.displayMode = "Player";
			Print("Setting Display Mode: Player");
			ldb_obj.text="Liquid-Wealth: Player";
		else
			Liquid_Wealth.db.profile.displayMode = "GuildBank";
			Print("Setting Display Mode: Guild Bank");
			ldb_obj.text="Liquid-Wealth: Guild Bank";
		end
		Liquid_Wealth:ConfigToolTip()
		tip:SmartAnchorTo(self)
		tip:Show()
	end
end
